Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.io
Class InputStreamReader

    java.lang.Object
      |
      +--java.io.Reader
            |
            +--java.io.InputStreamReader

Direct Known Subclasses:
  FileReader

public class InputStreamReader
extends Reader

An InputStreamReader is a bridge from byte streams to character streams: It reads bytes and translates them into characters according to a specified character encoding. The encoding that it uses may be specified by name, or the platform's default encoding may be accepted.

Each invocation of one of an InputStreamReader's read() methods may cause one or more bytes to be read from the underlying byte-input stream. To enable the efficient conversion of bytes to characters, more bytes may be read ahead from the underlying stream than are necessary to satisfy the current read operation.

For top efficiency, consider wrapping an InputStreamReader within a BufferedReader. For example:

     BufferedReader in
       = new BufferedReader(new InputStreamReader(System.in));

Since:
  JDK1.1
See Also:
  `BufferedReader`, `InputStream`, Character encodings

Fields inherited from class java.io.Reader
`lock`

Constructor Summary
`InputStreamReader(InputStream in)` Create an InputStreamReader that uses the default character encoding.
`InputStreamReader(InputStream in, String enc)` Create an InputStreamReader that uses the named character encoding.

Method Summary
`void` | `close()` Close the stream.
`String` | `getEncoding()` Returns the canonical name of the character encoding being used by this stream.
`int` | `read()` Read a single character.
`int` | `read(char[] cbuf, int off, int len)` Read characters into a portion of an array.
`boolean` | `ready()` Tell whether this stream is ready to be read.

Methods inherited from class java.io.Reader
`mark, markSupported, read, reset, skip`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### InputStreamReader

    public InputStreamReader(InputStream in)

  Create an InputStreamReader that uses the default character encoding.
  Parameters:
    `in` - An InputStream

### InputStreamReader

    public InputStreamReader(InputStream in,
                             String enc)
                      throws UnsupportedEncodingException

  Create an InputStreamReader that uses the named character encoding.
  Parameters:
    `in` - An InputStream
    `enc` - The name of a supported character encoding
  Throws:
    `UnsupportedEncodingException` - If the named encoding is not supported

Method Detail

### getEncoding

    public String getEncoding()

  Returns the canonical name of the character encoding being used by this stream. If this `InputStreamReader` was created with the `InputStreamReader(InputStream, String)` constructor then the returned encoding name, being canonical, may differ from the encoding name passed to the constructor. May return `null` if the stream has been closed.
  Returns:
    a String representing the encoding name, or possibly `null` if the stream has been closed
  See Also:
    Character encodings

### read

    public int read()
             throws IOException

  Read a single character.
  Overrides:
    `read` in class `Reader`
  Returns:
    The character read, or -1 if the end of the stream has been reached
  Throws:
    `IOException` - If an I/O error occurs

### read

    public int read(char[] cbuf,
                    int off,
                    int len)
             throws IOException

  Read characters into a portion of an array.
  Overrides:
    `read` in class `Reader`
  Parameters:
    `cbuf` - Destination buffer
    `off` - Offset at which to start storing characters
    `len` - Maximum number of characters to read
  Returns:
    The number of characters read, or -1 if the end of the stream has been reached
  Throws:
    `IOException` - If an I/O error occurs

### ready

    public boolean ready()
                  throws IOException

  Tell whether this stream is ready to be read. An InputStreamReader is ready if its input buffer is not empty, or if bytes are available to be read from the underlying byte stream.
  Overrides:
    `ready` in class `Reader`
  Throws:
    `IOException` - If an I/O error occurs

### close

    public void close()
               throws IOException

  Close the stream.
  Overrides:
    `close` in class `Reader`
  Throws:
    `IOException` - If an I/O error occurs

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.